import { Component } from '@angular/core';
import * as io from "socket.io-client";
import { Observable } from "rxjs/Observable";
import { NavParams } from "ionic-angular";
//<editor-fold desc="Template">
var HTML_TEMPLATE = "\n<ion-header>\n  <ion-navbar [color]=\"color\">\n    <ion-title>\n      {{ title }}\n    </ion-title>\n  </ion-navbar>\n</ion-header>\n\n<ion-content padding style=\"background: #e5e5e5;\">\n  <div style=\"position: relative;\">\n    <ol class=\"chat\" id=\"chat\">\n      <li *ngFor=\"let message of messages\" \n          [ngClass]=\"message.sender === user_id ? 'self': 'other'\">\n        <div class=\"avatar\">\n          <img\n            [src]=\"icon\"\n            draggable=\"false\"/>\n        </div>\n        <div class=\"msg\">\n          <p> {{ message.contenido }} </p>\n          <time>18:08</time>\n        </div>\n      </li>\n      \n    </ol>\n  </div>\n\n  <div>\n    <ion-textarea class=\"textarea\" \n    type=\"text\" \n    value=\"\" \n    [(ngModel)]=\"contenido\"\n    placeholder=\"Escribe un mensaje!\"></ion-textarea>\n    <button class=\"emojis btn btn-default\" (click)=\"sendMessage()\">Enviar</button>\n  </div>\n</ion-content>\n";
//</editor-fold>
//<editor-fold desc="Styles">
var CSS_STYLE = "\n::selection {\n    background: rgba(82, 179, 217, 0.3);\n    color: inherit;\n  }\n  a {\n    color: rgba(82, 179, 217, 0.9);\n  }\n\n  /* M E N U */\n\n  .menu {\n    position: fixed;\n    top: 0px;\n    left: 0px;\n    right: 0px;\n    width: 100%;\n    height: 50px;\n    background: rgba(82, 179, 217, 0.9);\n    z-index: 100;\n    -webkit-touch-callout: none;\n    -webkit-user-select: none;\n    -moz-user-select: none;\n    -ms-user-select: none;\n  }\n\n  .back {\n    position: absolute;\n    width: 90px;\n    height: 50px;\n    top: 0px;\n    left: 0px;\n    color: #fff;\n    line-height: 50px;\n    font-size: 30px;\n    padding-left: 10px;\n    cursor: pointer;\n  }\n  .back img {\n    position: absolute;\n    top: 5px;\n    left: 30px;\n    min-width: 40px;\n    height: 40px;\n    background-color: rgba(255, 255, 255, 0.98);\n    border-radius: 100%;\n    -webkit-border-radius: 100%;\n    -moz-border-radius: 100%;\n    -ms-border-radius: 100%;\n    margin-left: 15px;\n  }\n  .back:active {\n    background: rgba(255, 255, 255, 0.2);\n  }\n  .name {\n    position: absolute;\n    top: 3px;\n    left: 110px;\n    font-family: \"Lato\";\n    font-size: 25px;\n    font-weight: 300;\n    color: rgba(255, 255, 255, 0.98);\n    cursor: default;\n  }\n  .last {\n    position: absolute;\n    top: 30px;\n    left: 115px;\n    font-family: \"Lato\";\n    font-size: 11px;\n    font-weight: 400;\n    color: rgba(255, 255, 255, 0.6);\n    cursor: default;\n  }\n\n  /* M E S S A G E S */\n\n  .chat {\n    list-style: none;\n    background: none;\n    margin: 0;\n    padding: 0 0 50px 0;\n    margin-bottom: 10px;\n  }\n  .chat li {\n    padding: 0.6rem;\n    margin: 8px 0;\n    overflow: hidden;\n    align-items: center;\n    display: flex;\n  }\n  .chat .avatar {\n    min-width: 40px;\n    height: 40px;\n    position: relative;\n    display: block;\n    z-index: 2;\n    margin: 0 4px;\n    border-radius: 100%;\n    -webkit-border-radius: 100%;\n    -moz-border-radius: 100%;\n    -ms-border-radius: 100%;\n    background-color: rgba(255, 255, 255, 0.9);\n  }\n  .chat .avatar img {\n    width: 40px;\n    height: 40px;\n    border-radius: 100%;\n    -webkit-border-radius: 100%;\n    -moz-border-radius: 100%;\n    -ms-border-radius: 100%;\n    background-color: rgba(255, 255, 255, 0.9);\n    -webkit-touch-callout: none;\n    -webkit-user-select: none;\n    -moz-user-select: none;\n    -ms-user-select: none;\n  }\n  .chat .day {\n    position: relative;\n    display: block;\n    text-align: center;\n    color: #c0c0c0;\n    height: 20px;\n    text-shadow: 7px 0px 0px #e5e5e5, 6px 0px 0px #e5e5e5, 5px 0px 0px #e5e5e5,\n      4px 0px 0px #e5e5e5, 3px 0px 0px #e5e5e5, 2px 0px 0px #e5e5e5,\n      1px 0px 0px #e5e5e5, 1px 0px 0px #e5e5e5, 0px 0px 0px #e5e5e5,\n      -1px 0px 0px #e5e5e5, -2px 0px 0px #e5e5e5, -3px 0px 0px #e5e5e5,\n      -4px 0px 0px #e5e5e5, -5px 0px 0px #e5e5e5, -6px 0px 0px #e5e5e5,\n      -7px 0px 0px #e5e5e5;\n    box-shadow: inset 20px 0px 0px #e5e5e5, inset -20px 0px 0px #e5e5e5,\n      inset 0px -2px 0px #d7d7d7;\n    line-height: 38px;\n    margin-top: 5px;\n    margin-bottom: 20px;\n    cursor: default;\n    -webkit-touch-callout: none;\n    -webkit-user-select: none;\n    -moz-user-select: none;\n    -ms-user-select: none;\n  }\n\n  .other .msg {\n    order: 1;\n    border-top-left-radius: 0px;\n    box-shadow: -1px 2px 0px #d4d4d4;\n  }\n  /*.other:before {\n    content: \"\";\n    position: relative;\n    top: 0px;\n    right: 0px;\n    left: 40px;\n    width: 0px;\n    height: 0px;\n    border: 5px solid #fff;\n    border-left-color: transparent;\n    border-bottom-color: transparent;\n  }*/\n\n  .self {\n    justify-content: flex-end;\n    align-items: flex-end;\n  }\n  .self .msg {\n    order: 1;\n    border-bottom-right-radius: 0px;\n    box-shadow: 1px 2px 0px #d4d4d4;\n  }\n  .self .avatar {\n    order: 2;\n  }\n  /*.self .avatar:after {\n    content: \"\";\n    position: relative;\n    display: inline-block;\n    bottom: 19px;\n    right: 0px;\n    width: 0px;\n    height: 0px;\n    border: 5px solid #fff;\n    border-right-color: transparent;\n    border-top-color: transparent;\n    box-shadow: 0px 2px 0px #d4d4d4;\n  }*/\n\n  .msg {\n    background: white;\n    min-width: 50px;\n    padding: 15px;\n    border-radius: 4px;\n    box-shadow: 0px 2px 0px rgba(0, 0, 0, 0.07);\n  }\n  .msg p {\n    font-size: 1.3rem;\n    margin: 0 0 0.2rem 0;\n    color: #777;\n  }\n  .msg img {\n    position: relative;\n    display: block;\n    width: 450px;\n    border-radius: 5px;\n    box-shadow: 0px 0px 3px #eee;\n    transition: all 0.4s cubic-bezier(0.565, -0.26, 0.255, 1.41);\n    cursor: default;\n    -webkit-touch-callout: none;\n    -webkit-user-select: none;\n    -moz-user-select: none;\n    -ms-user-select: none;\n  }\n  @media screen and (max-width: 800px) {\n    .msg img {\n      width: 300px;\n    }\n  }\n  @media screen and (max-width: 550px) {\n    .msg img {\n      width: 200px;\n    }\n  }\n\n  .msg time {\n    font-size: 0.7rem;\n    color: #ccc;\n    margin-top: 3px;\n    float: right;\n    cursor: default;\n    -webkit-touch-callout: none;\n    -webkit-user-select: none;\n    -moz-user-select: none;\n    -ms-user-select: none;\n  }\n  .msg time:before {\n    content: \"\\f017\";\n    color: #ddd;\n    font-family: FontAwesome;\n    display: inline-block;\n    margin-right: 4px;\n  }\n\n  emoji {\n    display: inline-block;\n    height: 18px;\n    width: 18px;\n    background-size: cover;\n    background-repeat: no-repeat;\n    margin-top: -7px;\n    margin-right: 2px;\n    transform: translate3d(0px, 3px, 0px);\n  }\n  emoji.please {\n    background-image: url(https://imgur.com/ftowh0s.png);\n  }\n  emoji.lmao {\n    background-image: url(https://i.imgur.com/MllSy5N.png);\n  }\n  emoji.happy {\n    background-image: url(https://imgur.com/5WUpcPZ.png);\n  }\n  emoji.pizza {\n    background-image: url(https://imgur.com/voEvJld.png);\n  }\n  emoji.cryalot {\n    background-image: url(https://i.imgur.com/UUrRRo6.png);\n  }\n  emoji.books {\n    background-image: url(https://i.imgur.com/UjZLf1R.png);\n  }\n  emoji.moai {\n    background-image: url(https://imgur.com/uSpaYy8.png);\n  }\n  emoji.suffocated {\n    background-image: url(https://i.imgur.com/jfTyB5F.png);\n  }\n  emoji.scream {\n    background-image: url(https://i.imgur.com/tOLNJgg.png);\n  }\n  emoji.hearth_blue {\n    background-image: url(https://i.imgur.com/gR9juts.png);\n  }\n  emoji.funny {\n    background-image: url(https://i.imgur.com/qKia58V.png);\n  }\n\n  ::-webkit-scrollbar {\n    min-width: 12px;\n    width: 12px;\n    max-width: 12px;\n    min-height: 12px;\n    height: 12px;\n    max-height: 12px;\n    background: #e5e5e5;\n    box-shadow: inset 0px 50px 0px rgba(82, 179, 217, 0.9),\n      inset 0px -52px 0px #fafafa;\n  }\n\n  ::-webkit-scrollbar-thumb {\n    background: #bbb;\n    border: none;\n    border-radius: 100px;\n    border: solid 3px #e5e5e5;\n    box-shadow: inset 0px 0px 3px #999;\n  }\n\n  ::-webkit-scrollbar-thumb:hover {\n    background: #b0b0b0;\n    box-shadow: inset 0px 0px 3px #888;\n  }\n\n  ::-webkit-scrollbar-thumb:active {\n    background: #aaa;\n    box-shadow: inset 0px 0px 3px #7f7f7f;\n  }\n\n  ::-webkit-scrollbar-button {\n    display: block;\n    height: 26px;\n  }\n\n  /* T Y P E */\n\n  ion-textarea.textarea {\n    position: fixed;\n    bottom: 0px;\n    left: 0px;\n    right: 0px;\n    width: 100%;\n    height: 50px;\n    z-index: 99;\n    background: #fafafa;\n    border: none;\n    outline: none;\n    padding-left: 15px;\n    padding-right: 65px;\n    color: #666;\n    font-weight: 400;\n  }\n  .emojis {\n    position: fixed;\n    display: block;\n    bottom: 8px;\n    right: 7px;\n    width: 100px;\n    height: 34px;\n    background-size: cover;\n    z-index: 100;\n    cursor: pointer;\n  }\n  .emojis:active {\n    opacity: 0.9;\n  }\n";
//</editor-fold>
/**
 * Generated class for the ChatComponent component.
 *
 * See https://angular.io/api/core/Component for more info on Angular
 * Components.
 */
var ChatComponent = (function () {
    function ChatComponent(navParams) {
        this.navParams = navParams;
        this.contenido = '';
    }
    ChatComponent.prototype.ionViewDidLoad = function () {
        var _this = this;
        this.assignParams();
        this.getSala().subscribe(function (sala) { return _this.loadMessages(sala); });
        this.listenMessages().subscribe(function (message) { return _this.messages.push(message); });
    };
    ChatComponent.prototype.assignParams = function () {
        this.color = this.navParams.get('color');
        this.user_id = this.navParams.get('user_id');
        this.title = this.navParams.get('title');
        this.propietario = this.navParams.get('propietario');
        this.icon = this.navParams.get('icon');
        var socket_url = this.navParams.get('socket_url');
        this.socket = io(socket_url + "?propietario=" + this.propietario);
    };
    ChatComponent.prototype.loadMessages = function (sala) {
        this.messages = sala.mensajes;
    };
    ChatComponent.prototype.getSala = function () {
        var _this = this;
        return new Observable(function (observer) {
            _this.socket.on("sala", function (data) {
                observer.next(data);
            });
        });
    };
    ChatComponent.prototype.listenMessages = function () {
        var _this = this;
        return new Observable(function (observer) {
            _this.socket.on("new-message", function (data) {
                observer.next(data);
            });
        });
    };
    ChatComponent.prototype.sendMessage = function () {
        console.log('sendMessage');
        var message = {
            contenido: this.contenido,
            sender: this.user_id
        };
        this.contenido = '';
        this.socket.emit('send-message', { message: message, propietario: this.propietario });
    };
    ChatComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ionic-chat',
                    template: HTML_TEMPLATE,
                    styles: [CSS_STYLE]
                },] },
    ];
    /** @nocollapse */
    ChatComponent.ctorParameters = function () { return [
        { type: NavParams, },
    ]; };
    return ChatComponent;
}());
export { ChatComponent };
//# sourceMappingURL=chat.js.map